



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>GisUtil工具类：将WKT(wellKnownText)文本转换为ElasticSearch识别的空间对象字符串形式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">GisUtil工具类：将WKT(wellKnownText)文本转换为ElasticSearch识别的空间对象字符串形式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 00:31:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>ElasticSearch中的Geo Shape Type：</div>
<div>
<div><a href="https://www.elastic.co/guide/en/elasticsearch/reference/1.4/mapping-geo-shape-type.html" rel="external nofollow noreferrer">https://www.elastic.co/guide/en/elasticsearch/reference/1.4/mapping-geo-shape-type.html</a></div>
</div>
<div>&nbsp;</div>
<div>
<div>从熟知文本或熟知二进制数据中生成的&nbsp;ST_Geometry：</div>
</div>
<div>
<div><a href="http://resources.arcgis.com/zh-cn/help/main/10.2/index.html#/na/002n0000006n000000/" rel="external nofollow noreferrer">http://resources.arcgis.com/zh-cn/help/main/10.2/index.html#/na/002n0000006n000000/</a></div>
<div>&nbsp;</div>
<div>
<pre class="prettyprint linenums">package com.nihaorz.utils;

import com.vividsolutions.jts.geom.*;<br />
import com.vividsolutions.jts.io.ParseException;<br />
import com.vividsolutions.jts.io.WKTReader;<br />
import org.geotools.geometry.jts.JTSFactoryFinder;

/**<br />
 * Created by Administrator on 2016/4/1.<br />
 */<br />
public class GisUtil {

    private final static WKTReader wktReader = new WKTReader(JTSFactoryFinder.getGeometryFactory());

    /**<br />
     * 将WKT文本字符串转换为ES中的GeoShape字符串格式<br />
     * @param wkt<br />
     * @return<br />
     * @throws ParseException<br />
     */<br />
    public static String getESGeoTextFromWkt(String wkt) throws ParseException {<br />
        String result = null;<br />
        Geometry geom = wktReader.read(wkt);<br />
        String type = geom.getClass().getSimpleName().toLowerCase();<br />
        Point point;<br />
        MultiPoint multiPoint;<br />
        LineString lineString;<br />
        MultiLineString multiLineString;<br />
        Polygon polygon;<br />
        MultiPolygon multiPolygon;<br />
        if(type.equals("point")){<br />
            point = (Point) geom;<br />
            result = getESPointText(point);<br />
        }else if(type.equals("linestring")){<br />
            lineString = (LineString) geom;<br />
            result = getESLineStringText(lineString);<br />
        }else if(type.equals("polygon")){<br />
            polygon = (Polygon) geom;<br />
            result = getESPolygonText(polygon);<br />
        }else if(type.equals("multipoint")){<br />
            multiPoint = (MultiPoint) geom;<br />
            result = getESMultiPointText(multiPoint);<br />
        }else if(type.equals("multilinestring")){<br />
            multiLineString = (MultiLineString) geom;<br />
            result = getESMultiLineStringText(multiLineString);<br />
        }else if(type.equals("multipolygon")){<br />
            multiPolygon = (MultiPolygon) geom;<br />
            result = getESMultiPolygonText(multiPolygon);<br />
        }<br />
        return result;<br />
    }

    /**<br />
     * 通过MultiPolygon对象拼接中括号表示的字符串<br />
     * @param multiPolygon<br />
     * @return<br />
     */<br />
    private static String getESMultiPolygonText(MultiPolygon multiPolygon) throws ParseException {<br />
        Polygon polygon;<br />
        int num = multiPolygon.getNumGeometries();<br />
        StringBuffer sb = new StringBuffer("[");<br />
        for(int i = 0; i &lt; num; i++){<br />
            polygon = (Polygon) multiPolygon.getGeometryN(i);<br />
            sb.append(getESPolygonText(polygon)+",");<br />
        }<br />
        sb.setCharAt(sb.length() - 1, ']');<br />
        return sb.toString();<br />
    }

    /**<br />
     * 通过MultiLineString对象拼接中括号表示的字符串<br />
     * @param multiLineString<br />
     * @return<br />
     */<br />
    private static String getESMultiLineStringText(MultiLineString multiLineString) {<br />
        LineString lineString;<br />
        int num = multiLineString.getNumGeometries();<br />
        StringBuffer sb = new StringBuffer("[");<br />
        for(int i = 0; i &lt; num; i++){<br />
            lineString = (LineString) multiLineString.getGeometryN(i);<br />
            sb.append(getESLineStringText(lineString)+",");<br />
        }<br />
        sb.setCharAt(sb.length() - 1, ']');<br />
        return sb.toString();<br />
    }

    /**<br />
     * 通过MultiPoint对象拼接中括号表示的字符串<br />
     * @param multiPoint<br />
     * @return<br />
     */<br />
    private static String getESMultiPointText(MultiPoint multiPoint) {<br />
        Point point;<br />
        int num = multiPoint.getNumGeometries();<br />
        StringBuffer sb = new StringBuffer("[");<br />
        for(int i = 0; i &lt; num; i++){<br />
            point = (Point) multiPoint.getGeometryN(i);<br />
            sb.append(getESPointText(point)+",");<br />
        }<br />
        sb.setCharAt(sb.length() - 1, ']');<br />
        return sb.toString();<br />
    }

    /**<br />
     * 通过Polygon对象拼接中括号表示的字符串<br />
     * @param polygon<br />
     * @return<br />
     * @throws ParseException<br />
     */<br />
    private static String getESPolygonText(Polygon polygon){<br />
        String result;<br />
        /**<br />
         * 内部闭合环形的数量<br />
         */<br />
        int num = polygon.getNumInteriorRing();<br />
        if(num &gt; 0){<br />
            StringBuffer sb = new StringBuffer("["+getESLineStringText(polygon.getExteriorRing())+",");<br />
            for(int i = 0; i &lt; num; i++){<br />
                sb.append(getESLineStringText(polygon.getInteriorRingN(i))+",");<br />
            }<br />
            sb.setCharAt(sb.length() - 1, ']');<br />
            result = sb.toString();<br />
        }else{<br />
            result = "["+getESLineStringText(polygon.getExteriorRing())+"]";<br />
        }<br />
        return result;<br />
    }

    /**<br />
     * 通过LineString对象拼接中括号表示的字符串<br />
     * @param lineString<br />
     * @return<br />
     */<br />
    public static String getESLineStringText(LineString lineString){<br />
        Coordinate[] corrds = lineString.getCoordinates();<br />
        StringBuffer sb = new StringBuffer("[");<br />
        for(Coordinate corrd : corrds) {<br />
            sb.append(getCoordinateText(corrd)+",");<br />
        }<br />
        sb.setCharAt(sb.length() - 1, ']');<br />
        return sb.toString();<br />
    }

    /**<br />
     * 通过Point对象拼接中括号表示的字符串<br />
     * @param point<br />
     * @return<br />
     */<br />
    public static String getESPointText(Point point){<br />
        return getCoordinateText(point.getCoordinate());<br />
    }

    /**<br />
     * 通过Coordinate对象拼接中括号表示的字符串<br />
     * @param coord<br />
     * @return<br />
     */<br />
    public static String getCoordinateText(Coordinate coord) {<br />
        return "["+coord.x+","+coord.y+"]";<br />
    }

}
</pre>
</div>
<p>　　</p>
<p>　</p>
<p>附：</p>
<p>空心面的WKT文本格式：</p>
<p>POLYGON &nbsp;(( 114.69311270 32.15375671, 114.69311270 30.38273703, 117.16663685 30.38273703, 117.16663685 32.15375671, 114.69311270 32.15375671),( 115.46055456 31.36860465, 115.96824687 31.67558140, 116.33425760 31.37450805, 115.81475850 31.01440072, 115.46055456 31.36860465))</p>
<p>ArcMap中的预览效果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/629250/201604/629250-20160401144707035-952397038.png" /></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlm3lx9.html">NFS服务器配置文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwwjz3q.html">Mono Fragment之间转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/3904wxn8.html">iOS-性能优化2</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnlryx9.html">在Windows上将ReactNative集成到现有的Android项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rmjdd8.html">EF How to use context&period;Set and context&period;Entry&comma; which ships with EF4&period;1 &quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1ezg79.html">C&plus;&plus;线性序列容器&amp;lt&semi;vector&amp;gt&semi;简单总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1dyr2q.html">Android之一个简单计算器源代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ppdkv8.html">canvas绘制百分比圆环进度条</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj1od1q.html">JavaScript闭包小窥</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1m6k2q.html">&lbrack;转&rsqb;nodejs使用request发送http请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2v3p19.html">jenkins中shell脚本编写的两个注意点</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rez2o9.html">C&num;基础：委托之Action&amp;lt&semi;T&amp;gt&semi;和Func&amp;lt&semi;T&amp;gt&semi;的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w7llgq.html">python全栈第一章</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw7eod8.html">ViewpagerHandler</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyedp39.html">机器学习基石笔记：12 Nonlinear Transformation</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j157k49.html">Snort规则大探秘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnnpmjq.html">IOS&lowbar;多线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvez1wy9.html">np&period;repeat 与 np&period;tile</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kmnmlq.html">POJ 2155 Matrix （二维树状数组）题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2rl5d8.html">Java从零开始学十八&lpar;抽象类和接口&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39rwmnmq.html">BZOJ4152The Captain&lbrack;DIjkstra&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdxlxj8.html">python 使用pip安装第三方模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnl0rx9.html">能跨域和跨浏览器的flashcookie for jquery插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnle629.html">BZOJ 2005&colon; &lbrack;Noi2010&rsqb;能量采集</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kdgg69.html">PAT 1019&period; 数字黑洞 &lpar;20&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mx5l09.html">IO调度器</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnlxkj9.html">css position&comma; display&comma; float 内联元素、块级元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1d77zq.html">BZOJ 1014 【JSOI2008】 火星人prefix</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kd77r9.html">Linux shell的输入输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq46l5j8.html">Oracle XE http端口8080的修改</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
